# Class DefaultInstrument

Object
AbstractMetadata
ModifiableMetadata
ISOMetadata
DefaultInstrument

All Implemented Interfaces:
  `Serializable`, `Emptiable`, `LenientComparable`, `IdentifiedObject`, `Instrument`

public class DefaultInstrument extends ISOMetadata implements Instrument
Designations for the measuring instruments. The following properties are mandatory in a well-formed metadata according ISO 19115:
`MI_Instrument` `├─identifier……` Unique identification of the instrument. `│ └─code…………` Alphanumeric value identifying an instance in the namespace. `└─type……………………` Name of the type of instrument.

## Limitations

- Instances of this class are not synchronized for multi-threading. Synchronization, if needed, is caller's responsibility.
- Serialized objects of this class are not guaranteed to be compatible with future Apache SIS releases. Serialization support is appropriate for short term storage or RMI between applications running the same version of Apache SIS. For long term storage, use `XML` instead.

Since:
  0.3
See Also:
  - Serialized Form

- ## Nested Class Summary

  ### Nested classes/interfaces inherited from class ModifiableMetadata

  `ModifiableMetadata​.State`

- ## Field Summary

  ### Fields inherited from class ISOMetadata

  `identifiers`

- ## Constructor Summary

  Constructors
  Constructor
  Description
  `DefaultInstrument()`
  Constructs an initially empty instrument.
  `DefaultInstrument(Instrument object)`
  Constructs a new instance initialized with the values from the specified metadata object.

- ## Method Summary

  Modifier and Type
  Method
  Description
  `static DefaultInstrument`
  `castOrCopy(Instrument object)`
  Returns a SIS metadata implementation with the values of the given arbitrary implementation.
  `Collection<Citation>`
  `getCitations()`
  Returns the complete citation of the instrument.
  `InternationalString`
  `getDescription()`
  Returns the textual description of the instrument.
  `Identifier`
  `getIdentifier()`
  Returns the unique identification of the instrument.
  `Platform`
  `getMountedOn()`
  Returns the platform on which the instrument is mounted.
  `InternationalString`
  `getType()`
  Returns the name of the type of instrument.
  `void`
  `setCitations(Collection<? extends Citation> newValues)`
  Sets the complete citation of the instrument.
  `void`
  `setDescription(InternationalString newValue)`
  Sets the textual description of the instrument.
  `void`
  `setIdentifier(Identifier newValue)`
  Sets the unique identification of the instrument.
  `void`
  `setMountedOn(Platform newValue)`
  Sets the platform on which the instrument is mounted.
  `void`
  `setType(InternationalString newValue)`
  Sets the name of the type of instrument.

  ### Methods inherited from class ISOMetadata

  `getIdentifierMap, getIdentifiers, getStandard`

  ### Methods inherited from class ModifiableMetadata

  `checkWritePermission, collectionType, copyCollection, copyList, copyMap, copySet, deepCopy, nonNullCollection, nonNullList, nonNullMap, nonNullSet, singleton, state, writeCollection, writeList, writeMap, writeSet`

  ### Methods inherited from class AbstractMetadata

  `asMap, asTreeTable, clone, equals, equals, getInterface, hashCode, isEmpty, nilReasons, prune, toString`

  ### Methods inherited from class Object

  `finalize, getClass, notify, notifyAll, wait, wait, wait`

- ## Constructor Details

  - ### DefaultInstrument

    public DefaultInstrument()
    Constructs an initially empty instrument.

  - ### DefaultInstrument

    public DefaultInstrument(Instrument object)
    Constructs a new instance initialized with the values from the specified metadata object. This is a shallow copy constructor, because the other metadata contained in the given object are not recursively copied.
    Parameters:
      `object` - the metadata to copy values from, or `null` if none.
    See Also:
      - `castOrCopy(Instrument)`

- ## Method Details

  - ### castOrCopy

    public static DefaultInstrument castOrCopy(Instrument object)
    Returns a SIS metadata implementation with the values of the given arbitrary implementation. This method performs the first applicable action in the following choices:
    - If the given object is `null`, then this method returns `null`.
    - Otherwise if the given object is already an instance of `DefaultInstrument`, then it is returned unchanged.
    - Otherwise a new `DefaultInstrument` instance is created using the copy constructor and returned. Note that this is a shallow copy operation, because the other metadata contained in the given object are not recursively copied.
    Parameters:
      `object` - the object to get as a SIS implementation, or `null` if none.
    Returns:
      a SIS implementation containing the values of the given object (may be the given object itself), or `null` if the argument was null.

  - ### getCitations

    public Collection<Citation> getCitations()
    Returns the complete citation of the instrument.
    Specified by:
      `getCitations` in interface `Instrument`
    Returns:
      complete citation of the instrument.

  - ### setCitations

    public void setCitations(Collection<? extends Citation> newValues)
    Sets the complete citation of the instrument.
    Parameters:
      `newValues` - the new citation values.

  - ### getIdentifier

    public Identifier getIdentifier()
    Returns the unique identification of the instrument.
    Specified by:
      `getIdentifier` in interface `Instrument`
    Overrides:
      `getIdentifier` in class `ISOMetadata`
    Returns:
      unique identification of the instrument, or `null`.

  - ### setIdentifier

    public void setIdentifier(Identifier newValue)
    Sets the unique identification of the instrument.
    Overrides:
      `setIdentifier` in class `ISOMetadata`
    Parameters:
      `newValue` - the new identifier value.

  - ### getType

    public InternationalString getType()
    Returns the name of the type of instrument. Examples: framing, line-scan, push-broom, pan-frame.
    Specified by:
      `getType` in interface `Instrument`
    Returns:
      type of instrument, or `null`.

  - ### setType

    public void setType(InternationalString newValue)
    Sets the name of the type of instrument. Examples: framing, line-scan, push-broom, pan-frame.
    Parameters:
      `newValue` - the new type value.

  - ### getDescription

    public InternationalString getDescription()
    Returns the textual description of the instrument. `null` if unspecified.
    Specified by:
      `getDescription` in interface `Instrument`
    Returns:
      textual description, or `null`.

  - ### setDescription

    public void setDescription(InternationalString newValue)
    Sets the textual description of the instrument.
    Parameters:
      `newValue` - the new description value.

  - ### getMountedOn

    public Platform getMountedOn()
    Returns the platform on which the instrument is mounted. `null` if unspecified.
    Specified by:
      `getMountedOn` in interface `Instrument`
    Returns:
      platform on which the instrument is mounted, or `null`.

  - ### setMountedOn

    public void setMountedOn(Platform newValue)
    Sets the platform on which the instrument is mounted.
    Parameters:
      `newValue` - the new platform value.